QuizApp/urls.py
from django.urls import path
import QuizApp.views as quiz_app_views

app_name = "QuizApp"
urlpatterns = [
    path('', quiz_app_views.homepage_view, name='home'),
    path('quizzes/', quiz_app_views.list_quizzes, name='list_quizzes'),
    path('add-quiz/', quiz_app_views.add_quiz, name='add_quiz'),
    path('quiz-form/', quiz_app_views.add_quiz_form, name='add_quiz_form'),
    path('edit-quiz/<int:pk>/', quiz_app_views.edit_quiz, name='edit_quiz'),
    path('attempt-quiz/<int:pk>/', quiz_app_views.attempt_quiz, name='attempt_quiz'),
    path('quiz/<int:quiz_pk>/<int:qs_no>/', quiz_app_views.question_view, name='question_view'),
    path('save-responses/', quiz_app_views.save_quiz_response, name='save-responses'),
    path('show-responses/<int:quiz_pk>', quiz_app_views.show_all_response, name='show-responses'),
    path('curr-response/<int:quiz_pk>/<int:qs_no>/', quiz_app_views.show_current_response, name='curr-response'),
    path('add_trivia_quiz/', quiz_app_views.add_trivia_quiz, name='add-trivia-quiz')
]

testpress/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('QuizApp.urls')),
]

QuizApp/models.py
from django.db import models
import json
from urllib.request import urlopen


# https://opentdb.com/api.php?amount=10&difficulty=easy&type=multiple

class Quiz(models.Model):
    title = models.CharField(max_length=200)

    def __str__(self):
        return self.title


class Question(models.Model):
    QtypeChoices = [("Boolean", 0), ("Single_Answer", 1), ("Multiple_Answer", 2)]

    question_text = models.CharField(max_length=1000)
    question_type = models.IntegerField(choices=QtypeChoices, default=2)

    quiz = models.ForeignKey(Quiz, on_delete=models.CASCADE)

    def __str__(self):
        return self.question_text


class Answer(models.Model):
    answer_text = models.CharField(max_length=1000)
    is_correct = models.BooleanField()

    question = models.ForeignKey(Question, on_delete=models.CASCADE)

    def __str__(self):
        return self.answer_text


class QuizResponse(models.Model):
    name = models.CharField(max_length=200)
    email = models.CharField(max_length=200)
    Quiz = models.ForeignKey(Quiz, on_delete=models.CASCADE)
    # response_json = models.JSONField()
    response_json = models.CharField(max_length=10000)


def add_answer(answer_text, question, is_correct=False):
    ans = Answer(answer_text=answer_text, question=question, is_correct=is_correct)
    ans.save()
    return ans


def add_question(question_text, quiz, question_type=2):
    ques = Question(question_text=question_text, quiz=quiz, question_type=question_type)
    ques.save()
    return ques


def add_quiz(title):
    quiz = Quiz(title=title)
    quiz.save()
    return quiz


def add_quizzes_from_trivia(query_link, title=None, n_quizzes=1):
    """
    This Function is responsible to add new Quizzes using the questions downloaded from
    trivia API and write it to the database.

    :link: A link which will return json response with the list of questions.
           (i.e: https://opentdb.com/api.php?amount=500&difficulty=easy&type=multiple)

    :return:  None
    """

    data = json.loads(urlopen(query_link).read())['results'][: n_quizzes * 10]
    qs_count = 0
    for Q in data:
        if qs_count % 10 == 0:
            if not title:
                quiz = add_quiz(title=f"Quiz No: {qs_count // 10}")
            else:
                quiz = add_quiz(title=title)
        qs_count += 1

        question = add_question(Q['question'], quiz=quiz)
        add_answer(answer_text=Q['correct_answer'], question=question, is_correct=True)
        for ans in Q['incorrect_answers']:
            add_answer(answer_text=ans, question=question)

QuizApp/views.py
from django.shortcuts import render, HttpResponse, Http404, get_object_or_404, redirect, reverse
from django.template.loader import render_to_string
from django.contrib.messages import get_messages
from django.contrib import messages

from urllib.parse import urlencode

import QuizApp.models as quiz_app_models
import json
import time
import random


def homepage_view(request):
    """
        Renders homepage
    :param request:
    :return:
    """
    return render(request, 'QuizApp/home.html', context={})


def list_quizzes(request):
    """
        List all the available quizzes. or quizzes with matching search words.

    :param request:
    :return:
    """
    if request.method == 'GET':
        quiz_set = quiz_app_models.Quiz.objects.all()
        context = {
            'quiz_set': quiz_set,
        }
        return render(request, 'QuizApp/view_quizzes.html', context=context)
    elif request.method == 'POST':
        keywords = request.POST['keywords']


def add_quiz(request):
    """
    This function is responsible to add a new quiz.
    :param request:
    :return:
    """
    context = {
        "messages": get_messages(request),
    }
    return render(request, 'QuizApp/add_quiz.html', context=context)


def add_quiz_form(request):
    n_questions = 10
    n_options = 4

    if request.method == 'GET':
        context = {
            "qs_range": list(range(1, n_questions + 1)),
            "option_range": list(range(1, n_options + 1)),
            "messages": get_messages(request)
        }
        return render(request, 'QuizApp/add_quiz_form.html', context=context)
    elif request.method == 'POST':
        try:
            quiz_title = request.POST['quiz_title']
            quiz = quiz_app_models.add_quiz(title=quiz_title)
            print(request.POST)

            for qs_no in range(1, n_questions + 1):
                question_text = request.POST[f'option_text-{qs_no}']
                question = quiz_app_models.add_question(question_text=question_text, quiz=quiz)
                for opn in range(1, n_options + 1):
                    answer_text = request.POST[f'option_text-q{qs_no}-o{opn}']
                    is_correct = f'is_correct-q{qs_no}-o{opn}' in request.POST
                    quiz_app_models.add_answer(answer_text=answer_text, question=question, is_correct=is_correct)
            messages.success(request, 'Successfully created your Quiz')
            return redirect("QuizApp:home")
        except:
            messages.warning(request, "ERROR: Failed to create the Quiz.")


def add_trivia_quiz(request):
    if request.method == 'GET':

        context = {
            "messages": get_messages(request),
        }
        return render(request, 'QuizApp/trivia_quiz.html', context=context)
    elif request.method == 'POST':
        try:
            quiz_title = request.POST['title']
            api_url = request.POST['link']
            quiz_app_models.add_quizzes_from_trivia(query_link=api_url, title=quiz_title, n_quizzes=1)

            messages.success(request, 'Successfully added the Quiz')
            return redirect('QuizApp:add-trivia-quiz')
        except:
            messages.warning(request, 'ERROR: Failed to add the Quiz')
            return redirect('QuizApp:add-trivia-quiz')


def edit_quiz(request, pk):
    if request.method == 'GET':
        quiz = get_object_or_404(quiz_app_models.Quiz, pk=pk)

        context = {
            'quiz': quiz
        }
        return render(request, 'QuizApp/add_quiz.html', context=context)


def attempt_quiz(request, pk):
    if request.method == 'GET':
        quiz = get_object_or_404(quiz_app_models.Quiz, pk=pk)

        context = {
            'quiz': quiz
        }

        response_obj = render(request, 'QuizApp/attempt_quiz.html', context=context)
        # for key in request.COOKIES:
        #     response_obj.delete_cookie(key)

        response_obj.set_cookie("start_time", time.time())
        response_obj.set_cookie("QuizID", pk)
        response_obj.set_cookie("responses", {})
        response_obj.set_cookie("is_correct_array", {})
        return response_obj


def question_view(request, quiz_pk, qs_no):
    if request.method == 'GET':
        quiz = get_object_or_404(quiz_app_models.Quiz, pk=quiz_pk)

        if qs_no < 11:
            question = quiz.question_set.all()[qs_no - 1]
            options = list(question.answer_set.all())
            random.shuffle(options)
            context = {
                "quiz_pk": quiz_pk,
                "question": question,
                "options": options,
                "button_text": "Submit" if qs_no is 10 else "Next",
                "curr_qs_no": qs_no,
                "next_qs_no": qs_no + 1,
                "score": 0,
            }

            return render(request, 'QuizApp/question.html', context=context)

        elif qs_no == 11:
            return redirect("QuizApp:show-responses", quiz_pk)
            # return HttpResponse("Final submission implementation not complete.")
        else:
            return Http404()

    elif request.method == 'POST':
        quiz = get_object_or_404(quiz_app_models.Quiz, pk=quiz_pk)

        question = quiz.question_set.all()[qs_no - 1]

        submitted_answers = list(request.POST.keys())[1:]
        # response_obj = redirect('QuizApp:question_view', quiz_pk, qs_no + 1)
        response_obj = redirect('QuizApp:curr-response', quiz_pk, qs_no)

        curr_cookie = request.COOKIES
        curr_responses = json.loads(curr_cookie["responses"])
        curr_responses[str(qs_no)] = submitted_answers
        response_obj.set_cookie("responses", json.dumps(curr_responses))
        return response_obj


def get_color(is_selected, is_correct):
    if is_selected and is_correct:
        return 'green'
    elif not is_selected and not is_correct:
        return 'black'
    else:
        return 'red'


def show_current_response(request, quiz_pk, qs_no, return_type="http-response"):
    submitted_responses = json.loads(request.COOKIES["responses"])[str(qs_no)]
    quiz = get_object_or_404(quiz_app_models.Quiz, pk=quiz_pk)
    question = quiz.question_set.all()[qs_no - 1]
    correct_responses = [str(answer.pk) for answer in question.answer_set.all() if answer.is_correct]
    correct_submission = (sorted(submitted_responses) == sorted(correct_responses))
    if qs_no is 10:
        end_time = time.time()

    context = {
        "quiz_pk": quiz_pk,
        "question": question,
        "is_answered": True,
        "curr_qs_no": qs_no,
        "next_qs_no": qs_no + 1,
        "button_text": "Next",
        "options": [(option, str(option.pk) in submitted_responses, str(option.pk) in correct_responses,
                     get_color(str(option.pk) in submitted_responses, str(option.pk) in correct_responses))
                    for option in question.answer_set.all()],
        "correct_submission": correct_submission,
        "correct_options": [option for option in question.answer_set.all() if option.is_correct],
        "return_string": return_type == 'string',
    }
    if return_type == 'string':
        return render_to_string('QuizApp/response_view.html', context=context)

    response_obj = render(request, 'QuizApp/quiz_response.html', context=context)

    new_correct_array = json.loads(request.COOKIES["is_correct_array"])
    new_correct_array[str(qs_no)] = correct_submission

    response_obj.set_cookie("is_correct_array", json.dumps(new_correct_array))

    if qs_no is 10 and (
            'end_time' not in request.COOKIES or request.COOKIES['end_time'] < request.COOKIES["start_time"]):
        response_obj.set_cookie('end_time', end_time)
    return response_obj


def show_all_response(request, quiz_pk):
    # submitted_responses = json.loads(request.COOKIES["responses"])
    html_response = ""

    # quiz = get_object_or_404(quiz_app_models.Quiz, pk=quiz_pk)
    for qs_no in range(1, 11):
        html_response += "\n" + show_current_response(request, quiz_pk, qs_no, return_type='string')

    start_time = float(request.COOKIES['start_time'])
    end_time = float(request.COOKIES['end_time'])
    # time taken
    minutes, seconds = divmod((int(end_time - start_time)), 60)

    score = sum(map(lambda x: int(x), json.loads(request.COOKIES["is_correct_array"]).values()))

    context = {
        "html_response": html_response,
        "minutes": minutes,
        "seconds": seconds,
        "score": score,
    }
    response_obj = render(request, 'QuizApp/final_response.html', context=context)
    return response_obj


def save_quiz_response(request):
    if request.method == 'GET':
        return render(request, 'QuizApp/user_form.html')
    if request.method == 'POST':
        name = request.POST["name"]
        email = request.POST["email"]

        curr_cookie = request.COOKIES
        del curr_cookie['csrftoken']
        quiz = get_object_or_404(quiz_app_models.Quiz, pk=curr_cookie["QuizID"])
        quiz_response_obj = quiz_app_models.QuizResponse(name=name, email=email, Quiz=quiz, response_json=curr_cookie)
        quiz_response_obj.save()

        return render(request, 'QuizApp/user_form.html', {"saved": True})

QuizApp/templates/QuizApp/add_quiz.html
{% extends 'QuizApp/base.html' %}

{% block body %}
    <a class="btn btn-secondary" href="{% url 'QuizApp:add-trivia-quiz' %}" role="button">Add Quiz using trivia API</a>
    <a class="btn btn-secondary" href="{% url 'QuizApp:add_quiz_form' %}" role="button">Add a Quiz Manually</a>
{% endblock %}

QuizApp/templates/QuizApp/add_quiz_form.html
{% extends 'QuizApp/base.html' %}

{% block body %}
    <form method="post">
        {% csrf_token %}
        <div class="row">
            <div class="col-sm-10"></div>
            <div class="col-sm-2">
                <button type="submit" class="btn btn-primary">Submit</button>
            </div>
        </div>

        <div class="form-group">
            <label for="quiz_title"><strong>Quiz Title</strong></label>
            <input type="text" class="form-control" id="quiz_title" name="quiz_title" required
                   placeholder="Title of your Quiz.">
        </div>
        <hr>
        {% for qs_no in qs_range %}
            <div class="form-group">
                <label for="option_text-{{ qs_no }}"><strong>Question {{ qs_no }}: </strong></label>
                {#                <div class="col-sm-10">#}
                <input type="text" class="form-control" id="option_text-{{ qs_no }}" name="option_text-{{ qs_no }}"
                       placeholder="Enter your Question." required>
                {#                </div>#}
            </div>
            {% for opn in option_range %}
                <div class="form-group row">
                    <div class="col-sm-1"></div>
                    <label for="option_text-q{{ qs_no }}-o{{ opn }}"
                           class="col-sm-1 col-form-label">Option {{ opn }}: </label>
                    <div class="col-sm-8">
                        <input type="text" class="form-control" id="option_text-q{{ qs_no }}-o{{ opn }}"
                               name="option_text-q{{ qs_no }}-o{{ opn }}" required>
                    </div>
                    <div class="col-sm-1"></div>
                    <div class="form-check form-check-inline">
                        <input class="form-check-input" type="checkbox" id="is_correct-q{{ qs_no }}-o{{ opn }}"
                               name="is_correct-q{{ qs_no }}-o{{ opn }}" value="option1">
                        <label class="form-check-label" for="is_correct-q{{ qs_no }}-o{{ opn }}">Correct</label>
                    </div>
                </div>
            {% endfor %}
        {% endfor %}
        <button type="submit" class="btn btn-primary btn-lg btn-block">Submit</button>
    </form>
{% endblock %}

QuizApp/templates/QuizApp/attempt_quiz.html
{% extends 'QuizApp/base.html' %}

{% block body %}
    <div class="form-check">
        <h3>{{ quiz.title }}</h3><br>
        {#        {% for question in quiz.question_set.all %}#}
        {#            {% include 'QuizApp/question.html' with is_answered=False %}#}
        {#        {% endfor %}#}
        <a class="btn btn-secondary" href="{% url 'QuizApp:question_view' quiz.pk 1 %}"
           role="button">Start Quiz</a>
    </div>
{% endblock body %}


{% block script %}
{% endblock script %}

QuizApp/templates/QuizApp/base.html
<!doctype html>
<html lang="en">
<head>
    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

    <!-- Bootstrap CSS -->
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css"
          integrity="sha384-JcKb8q3iqJ61gNV9KGb8thSsNjpSL0n8PARn9HuZOnIxN0hoP+VmmDGMN5t9UJ0Z" crossorigin="anonymous">

    <title>{% if title %} {{ title }} {% else %} Testpress {% endif %}</title>
</head>
<body>
{% include 'navbar.html' %}

<div class="container" style="padding: 10px;">
    {% if messages %}
        <ul class="messages">
            {% for message in messages %}
                <div class="alert alert-{{ message.tags }}" role="alert">
                    {{ message }}
                </div>
            {% endfor %}
        </ul>
    {% endif %}

    {% block body %}
    {% endblock body %}
</div>

{% block script %}
{% endblock script %}

<!-- Optional JavaScript -->
<!-- jQuery first, then Popper.js, then Bootstrap JS -->
<script src="https://code.jquery.com/jquery-3.5.1.slim.min.js"
        integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj"
        crossorigin="anonymous"></script>
<script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.1/dist/umd/popper.min.js"
        integrity="sha384-9/reFTGAW83EW2RDu2S0VKaIzap3H66lZH81PoYlFhbGU+6BZp6G7niu735Sk7lN"
        crossorigin="anonymous"></script>
<script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"
        integrity="sha384-B4gt1jrGC7Jh4AgTPSdUtOBvfO8shuf57BaghqFfPlYxofvL8/KUEfYiJOMMV+rV"
        crossorigin="anonymous"></script>
</body>
</html>

QuizApp/templates/QuizApp/final_response.html
{% extends 'QuizApp/base.html' %}

{% block body %}
    <div class="row">
        <div class="col-sm-5">
            <span>Time Taken: {{ minutes }} minutes, {{ seconds }} seconds</span>
        </div>
        <div class="col-sm-4">Your Score: {{ score }}</div>
        <div class="col-sm-3">
            <a class="btn btn-secondary" href="{% url 'QuizApp:save-responses' %}" role="button">Save responses to
                Database</a>
        </div>
    </div>
    <hr>
    {% autoescape off %}
        {{ html_response }}
    {% endautoescape %}
{% endblock %}

QuizApp/templates/QuizApp/home.html
{% extends 'QuizApp/base.html' %}

{% block body %}
    <a class="btn btn-secondary" href="{% url 'QuizApp:list_quizzes' %}" role="button">Show Quizzes</a>
    <a class="btn btn-secondary" href="{% url 'QuizApp:add_quiz' %}" role="button">Add a new Quiz</a>
{% endblock %}

QuizApp/templates/QuizApp/question.html
{% extends 'QuizApp/base.html' %}


{% block body %}
    {% if not is_answered %}
        <form method="post">
            {% csrf_token %}
            <div class="form-group container">
                {% autoescape off %}
                    <div class="row">
                        <span><strong>Q. {{ curr_qs_no }}: {{ question.question_text }}</strong></span><br>
                    </div>
                    {% for option in options %}
                        <div class="row" style="margin-left: 15px; margin-top: 10px;">
                            <input class="form-check-input" type="checkbox" name="{{ option.pk }}" id="{{ option.pk }}"
                                   value="{{ option.pk }}">
                            <label class="form-check-label" for="{{ option.pk }}">{{ option.answer_text }}</label>
                        </div>
                    {% endfor %}
                {% endautoescape %}
                <div class="row" style="margin-top: 15px;">
                    {#                <a class="btn btn-secondary" href="{% url 'QuizApp:question_view' quiz_pk next_qs_no %}"#}
                    {#                   role="button">{{ button_text }}</a>#}
                    <button class="btn btn-secondary" type="submit">Submit</button>
                </div>
            </div>
        </form>
    {% endif %}
{% endblock %}

{% block script %}
{% endblock %}

QuizApp/templates/QuizApp/quiz_response.html
{% extends 'QuizApp/base.html' %}

{% block body %}
    {% include 'QuizApp/response_view.html' %}
    <div class="row" style="margin-top: 15px;">
        <a class="btn btn-secondary" href="{% url 'QuizApp:question_view' quiz_pk next_qs_no %}"
           role="button">{{ button_text }}</a>
    </div>
{% endblock body %}

QuizApp/templates/QuizApp/response_view.html
    <div class="form-group container">
        {% autoescape off %}
            <div class="row">
                <span><strong>Q. {{ curr_qs_no }}: {{ question.question_text }}</strong></span><br>
            </div>
            {% for option, is_selected, is_correct, color in options %}

                <div class="row" style="margin-left: 15px; margin-top: 10px;">
                    <input class="form-check-input" type="checkbox" name="{{ option.pk }}" id="{{ option.pk }}"
                           value="{{ option.pk }}" {% if is_selected %}checked{% endif %} disabled>
                    <label class="form-check-label" for="{{ option.pk }}"
                           style="color: {{ color }};">{{ option.answer_text }}</label>
                </div>
            {% endfor %}
            {% if correct_submission %}
                <div class="row">
                    <strong><span style="color: green;">Submitted response are correct.</span></strong>
                </div>
            {% else %}
                <div class="row"><strong><span style="color: red;">Your response was incorrect!</span></strong></div>
                <div class="row"><strong><span>Correct options are: </span></strong></div>
                {% for option in correct_options %}
                    <div class="row" style="margin-left: 15px;"><span>{{ option.answer_text }}</span></div>
                {% endfor %}
            {% endif %}
        {% endautoescape %}
    </div>

QuizApp/templates/QuizApp/trivia_quiz.html
{% extends 'QuizApp/base.html' %}

{% block body %}

    <form method="post">
        {% csrf_token %}
        <div class="form-group">
            <label for="title">Quiz title</label>
            <input type="text" class="form-control" id="title" name="title" placeholder="Enter the Quiz Title">
        </div>
        <div class="form-group">
            <label for="link">Link</label>
            <input type="url" class="form-control" id="link" name="link" placeholder="Enter a trivia API link">
        </div>
        <button type="submit" class="btn btn-primary">Submit</button>
    </form>
{% endblock %}

QuizApp/templates/QuizApp/user_form.html
{% extends 'QuizApp/base.html' %}

{% block body %}

    {% if not saved %}
        <form method="post">
            {% csrf_token %}
            <div class="form-group">
                <label for="name">Name</label>
                <input type="text" class="form-control" id="name" name="name" placeholder="Enter your name">
            </div>
            <div class="form-group">
                <label for="email">Email address</label>
                <input type="email" class="form-control" id="email" name="email" aria-describedby="emailHelp"
                       placeholder="Enter email">
                <small id="emailHelp" class="form-text text-muted">We'll never share your email with anyone
                    else.</small>
            </div>
            <button type="submit" class="btn btn-primary">Submit</button>
        </form>
    {% else %}
        <div class="alert alert-success" role="alert">
            Successfully saved your response.
        </div>
    {% endif %}
{% endblock body %}

QuizApp/templates/QuizApp/view_quizzes.html
{% extends 'QuizApp/base.html' %}

{% block body %}
    {% for quiz in quiz_set %}
        <div class="row quiz_row" style="margin: 10px; padding: 10px;">
            <div class="col-sm-8">
                {{ quiz.title }}
            </div>
            <div class="col-sm-2">
                <a class="btn btn-secondary" href="{% url 'QuizApp:attempt_quiz' quiz.pk %}" role="button">Attempt</a>&nbsp;
                <a class="btn btn-secondary" href="{% url 'QuizApp:edit_quiz' quiz.pk %}" role="button">Edit</a>
            </div>
        </div>
    {% endfor %}
{% endblock %}